package wsrl.counter.client;

import java.io.FileInputStream;
import javax.xml.rpc.Stub;

import org.apache.axis.message.addressing.EndpointReferenceType;

import org.globus.axis.util.Util;
import org.globus.wsrf.encoding.ObjectDeserializer;

import org.oasis.wsrf.lifetime.Destroy;

import org.xml.sax.InputSource;
    
import wsrl.counter.Counter;
import wsrl.counter.service.CounterServiceAddressingLocator;

public class CounterDestroy {
    static {
        Util.registerTransport();
    }    

    public static void main(String[] args) throws Exception {
        CounterServiceAddressingLocator locator =
            new CounterServiceAddressingLocator();
        
	try {
            String eprFile = args[0];

            // Get endpoint reference of WS-Resource from file
            FileInputStream fis = new FileInputStream(eprFile);
            EndpointReferenceType endpoint = (EndpointReferenceType)
                ObjectDeserializer.deserialize(
                    new InputSource(fis), EndpointReferenceType.class
                );
            fis.close();

            // Get counter WS-Resource
            Counter counter = locator.getCounterPort(endpoint);

            // Configure security
            SecurityHelper.setSecurity((Stub) counter);            

            // Destroy counter WS-Resource
            System.out.print("Destroying counter WS-Resource ...");
            counter.destroy(new Destroy());
            System.out.println(" done.");                        
	} catch (ArrayIndexOutOfBoundsException e) {
            System.err.println("Usage: CounterDestroy <EPR file>");
	}	    
    }
}
