package wsrl.counter.client;

import javax.xml.rpc.Stub;

import org.globus.axis.gsi.GSIConstants;
import org.globus.wsrf.impl.security.authentication.Constants;
import org.globus.wsrf.impl.security.authorization.NoAuthorization;

public class SecurityHelper {

    public static void setSecurity(Stub stub) {
        String clientDescriptor = System.getProperty("client.descriptor");
        if (clientDescriptor != null) {
            System.out.println("Using client descriptor: " + clientDescriptor);
            stub._setProperty(
                Constants.CLIENT_DESCRIPTOR_FILE, clientDescriptor
            );
        } else {
            // Default: transport-level security and no service authorization
            System.out.println("Using transport security without service authz");
            stub._setProperty(
                GSIConstants.GSI_TRANSPORT, Constants.SIGNATURE
            );
            stub._setProperty(
                Constants.AUTHORIZATION, NoAuthorization.getInstance()
            );        
        }        
    }  
}
